﻿Imports C1.Win.C1Chart

Public Class Form1

    Private xp As Single() = New Single(499) {}
    Private yp As Single() = New Single(499) {}
    Private i As Integer

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        Dim rndValue As New Random()

        For i = 0 To 499
            xp(i) = i
            yp(i) = rndValue.[Next](100)
        Next

        C1Chart1.ChartGroups.ChartGroupsCollection(0).ChartData.SeriesList.Clear()

        Dim cdseries As ChartDataSeries = C1Chart1.ChartGroups.ChartGroupsCollection(0).ChartData.SeriesList.AddNewSeries()

        cdseries.X.CopyDataIn(xp)
        cdseries.Y.CopyDataIn(yp)

        C1Chart1.ChartGroups.ChartGroupsCollection(0).ChartData.SeriesList(0).LineStyle.Color = Color.CornflowerBlue


        Dim cd As ChartData = C1Chart1.ChartGroups.Group0.ChartData

        ' Adjust all the series symbols.  Want shape, but zero size
        ' If the shape is none, then it will not highlight
        Dim cdsc As ChartDataSeriesCollection = cd.SeriesList
        For Each cds As ChartDataSeries In cdsc
            cds.SymbolStyle.Shape = SymbolShapeEnum.Dot
            cds.SymbolStyle.Size = 0
        Next

        ' preset the highlight object parameters for the group.
        Dim dhl As DataHighlight = cd.HighLight
        dhl.SymbolStyle.Color = Color.Blue
        dhl.SymbolStyle.Shape = SymbolShapeEnum.Dot
        dhl.SymbolStyle.Size = 6

        ' Custom indicates user code will handle setting the series and point index.
        dhl.Activation = HighlightActivationEnum.[Custom]

        ' Set up the mouse move handler.
        AddHandler C1Chart1.MouseMove, AddressOf c1Chart1_MouseMove
    End Sub

    Private Sub c1Chart1_MouseMove(sender As Object, e As MouseEventArgs)
        ' always get the Highlight object.  It will be set or cleared
        Dim dhl As DataHighlight = C1Chart1.ChartGroups.Group0.ChartData.HighLight

        ' if both are changed to valid values, then something needs to be highlighted
        Dim seriesIndex As Integer = -1, pointIndex As Integer = -1

        ' only check if the mouse is in the PlotArea.
        If C1Chart1.ChartRegionFromCoord(e.X, e.Y) = ChartRegionEnum.PlotArea Then
            Dim grp As ChartGroup = C1Chart1.ChartGroups.Group0
            Dim dist As Integer = 0

            ' if there is a single series in the chart like the google chart sample, then series index is always 0
            ' and finding the closest series is not required.
            '
            ' find the closest XCoord.
            If grp.CoordToDataIndex(e.X, e.Y, CoordinateFocusEnum.XCoord, seriesIndex, pointIndex, dist) Then
                ' if there are multiple series in the chart, then find the closest series.  this assumes that
                ' each series has the same X values.  if there is only 1 series, seriesIndex is already correct
                If grp.CoordToSeriesIndex(e.X, e.Y, PlotElementEnum.Series, seriesIndex, dist) Then
                    dhl.SeriesIndex = seriesIndex
                    dhl.PointIndex = pointIndex

                    label1.Text = "Data CoordinateX : " + C1Chart1.ChartGroups(0).ChartData.SeriesList(seriesIndex).X(pointIndex).ToString()
                    label2.Text = "Data CoordinateY: " + C1Chart1.ChartGroups(0).ChartData.SeriesList(seriesIndex).Y(pointIndex).ToString()
                End If
            End If
        End If

        ' if either of these indices is has not been set, then the mouse must
        ' not be in an appropriate location to highlight the data, so clear the highlight object.
        If seriesIndex = -1 OrElse pointIndex = -1 Then
            dhl.SeriesIndex = -1
            dhl.PointIndex = -1
        End If
    End Sub


End Class
